# dasl-api
Interact with the Antimatter ASL API

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.0.4
- Package version: 0.0.4
- Generator version: 7.10.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.8+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import dasl_api
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import dasl_api
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import dasl_api
from dasl_api.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://api.asl.antimatter.io/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = dasl_api.Configuration(
    host = "https://api.asl.antimatter.io/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure Bearer authorization (JWT): account_identity
configuration = dasl_api.Configuration(
    access_token = os.environ["BEARER_TOKEN"]
)


# Enter a context with an instance of the API client
with dasl_api.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = dasl_api.ContentV1alpha1Api(api_client)
    workspace = 'workspace_example' # str | The name of the workspace

    try:
        api_response = api_instance.content_v1_alpha1_get_mitre_enterprise(workspace)
        print("The response of ContentV1alpha1Api->content_v1_alpha1_get_mitre_enterprise:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling ContentV1alpha1Api->content_v1_alpha1_get_mitre_enterprise: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.asl.antimatter.io/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ContentV1alpha1Api* | [**content_v1_alpha1_get_mitre_enterprise**](docs/ContentV1alpha1Api.md#content_v1_alpha1_get_mitre_enterprise) | **GET** /apis/content/v1alpha1/workspaces/{workspace}/mitre/enterprise | 
*ContentV1alpha1Api* | [**content_v1_alpha1_get_mitre_enterprise_details**](docs/ContentV1alpha1Api.md#content_v1_alpha1_get_mitre_enterprise_details) | **GET** /apis/content/v1alpha1/workspaces/{workspace}/mitre/enterprise/{identifier} | 
*ContentV1alpha1Api* | [**content_v1_alpha1_get_preset_data_sources**](docs/ContentV1alpha1Api.md#content_v1_alpha1_get_preset_data_sources) | **GET** /apis/content/v1alpha1/workspaces/{workspace}/datasources | 
*ContentV1alpha1Api* | [**content_v1_alpha1_get_preset_datasource**](docs/ContentV1alpha1Api.md#content_v1_alpha1_get_preset_datasource) | **GET** /apis/content/v1alpha1/workspaces/{workspace}/presets/datasource/{name} | 
*ContentV1alpha1Api* | [**content_v1_alpha1_get_preset_datasource_list**](docs/ContentV1alpha1Api.md#content_v1_alpha1_get_preset_datasource_list) | **GET** /apis/content/v1alpha1/workspaces/{workspace}/presets/datasource | 
*CoreV1alpha1Api* | [**core_v1_alpha1_create_data_source**](docs/CoreV1alpha1Api.md#core_v1_alpha1_create_data_source) | **POST** /apis/core/v1alpha1/workspaces/{workspace}/datasources | 
*CoreV1alpha1Api* | [**core_v1_alpha1_create_rule**](docs/CoreV1alpha1Api.md#core_v1_alpha1_create_rule) | **POST** /apis/core/v1alpha1/workspaces/{workspace}/rules | 
*CoreV1alpha1Api* | [**core_v1_alpha1_create_transform**](docs/CoreV1alpha1Api.md#core_v1_alpha1_create_transform) | **POST** /apis/core/v1alpha1/workspaces/{workspace}/transforms | 
*CoreV1alpha1Api* | [**core_v1_alpha1_delete_data_source**](docs/CoreV1alpha1Api.md#core_v1_alpha1_delete_data_source) | **DELETE** /apis/core/v1alpha1/workspaces/{workspace}/datasources/{name} | 
*CoreV1alpha1Api* | [**core_v1_alpha1_delete_rule**](docs/CoreV1alpha1Api.md#core_v1_alpha1_delete_rule) | **DELETE** /apis/core/v1alpha1/workspaces/{workspace}/rules/{name} | 
*CoreV1alpha1Api* | [**core_v1_alpha1_delete_transform**](docs/CoreV1alpha1Api.md#core_v1_alpha1_delete_transform) | **DELETE** /apis/core/v1alpha1/workspaces/{workspace}/transforms/{name} | 
*CoreV1alpha1Api* | [**core_v1_alpha1_get_data_source**](docs/CoreV1alpha1Api.md#core_v1_alpha1_get_data_source) | **GET** /apis/core/v1alpha1/workspaces/{workspace}/datasources/{name} | 
*CoreV1alpha1Api* | [**core_v1_alpha1_get_rule**](docs/CoreV1alpha1Api.md#core_v1_alpha1_get_rule) | **GET** /apis/core/v1alpha1/workspaces/{workspace}/rules/{name} | 
*CoreV1alpha1Api* | [**core_v1_alpha1_get_transform**](docs/CoreV1alpha1Api.md#core_v1_alpha1_get_transform) | **GET** /apis/core/v1alpha1/workspaces/{workspace}/transforms/{name} | 
*CoreV1alpha1Api* | [**core_v1_alpha1_list_data_sources**](docs/CoreV1alpha1Api.md#core_v1_alpha1_list_data_sources) | **GET** /apis/core/v1alpha1/workspaces/{workspace}/datasources | 
*CoreV1alpha1Api* | [**core_v1_alpha1_list_rules**](docs/CoreV1alpha1Api.md#core_v1_alpha1_list_rules) | **GET** /apis/core/v1alpha1/workspaces/{workspace}/rules | 
*CoreV1alpha1Api* | [**core_v1_alpha1_list_transforms**](docs/CoreV1alpha1Api.md#core_v1_alpha1_list_transforms) | **GET** /apis/core/v1alpha1/workspaces/{workspace}/transforms | 
*CoreV1alpha1Api* | [**core_v1_alpha1_replace_data_source**](docs/CoreV1alpha1Api.md#core_v1_alpha1_replace_data_source) | **PUT** /apis/core/v1alpha1/workspaces/{workspace}/datasources/{name} | 
*CoreV1alpha1Api* | [**core_v1_alpha1_replace_rule**](docs/CoreV1alpha1Api.md#core_v1_alpha1_replace_rule) | **PUT** /apis/core/v1alpha1/workspaces/{workspace}/rules/{name} | 
*CoreV1alpha1Api* | [**core_v1_alpha1_replace_transform**](docs/CoreV1alpha1Api.md#core_v1_alpha1_replace_transform) | **PUT** /apis/core/v1alpha1/workspaces/{workspace}/transforms/{name} | 
*CoreV1alpha1Api* | [**dbui_v1_alpha1_post_metrics**](docs/CoreV1alpha1Api.md#dbui_v1_alpha1_post_metrics) | **POST** /apis/core/v1alpha1/workspaces/{workspace}/metrics | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_authenticate**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_authenticate) | **GET** /apis/dbui/v1alpha1/authenticate | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_autoloader_preview**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_autoloader_preview) | **POST** /apis/dbui/v1alpha1/workspaces/{workspace}/autoloader-preview | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_check_schema_file**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_check_schema_file) | **GET** /apis/dbui/v1alpha1/workspaces/{workspace}/check-schema-file | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_create_function**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_create_function) | **POST** /apis/dbui/v1alpha1/workspaces/{workspace}/create-function | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_create_notebook**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_create_notebook) | **POST** /apis/dbui/v1alpha1/workspaces/{workspace}/create-notebook | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_dismiss_operational_alerts**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_dismiss_operational_alerts) | **POST** /apis/dbui/v1alpha1/workspaces/{workspace}/alerts/dismiss | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_get_data_source_summary**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_get_data_source_summary) | **GET** /apis/dbui/v1alpha1/workspaces/{workspace}/datasources/summary | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_get_notable_by_id**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_get_notable_by_id) | **GET** /apis/dbui/v1alpha1/workspaces/{workspace}/notables/by-id/{id} | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_get_notables**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_get_notables) | **GET** /apis/dbui/v1alpha1/workspaces/{workspace}/notables | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_get_notables_summary**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_get_notables_summary) | **GET** /apis/dbui/v1alpha1/workspaces/{workspace}/notables/summary | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_get_observable_events**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_get_observable_events) | **GET** /apis/dbui/v1alpha1/workspaces/{workspace}/observables/kinds/{kind}/{value}/events | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_get_observable_kind**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_get_observable_kind) | **GET** /apis/dbui/v1alpha1/workspaces/{workspace}/observables/kinds/{kind} | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_get_observable_top10**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_get_observable_top10) | **GET** /apis/dbui/v1alpha1/workspaces/{workspace}/observables/top10 | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_get_operational_alert_by_id**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_get_operational_alert_by_id) | **GET** /apis/dbui/v1alpha1/workspaces/{workspace}/alerts/by-id/{id} | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_get_operational_alerts**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_get_operational_alerts) | **GET** /apis/dbui/v1alpha1/workspaces/{workspace}/alerts | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_get_operational_alerts_summary**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_get_operational_alerts_summary) | **GET** /apis/dbui/v1alpha1/workspaces/{workspace}/alerts/summary | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_list_columns**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_list_columns) | **GET** /apis/dbui/v1alpha1/workspaces/{workspace}/tables/{table}/columns | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_list_external_locations**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_list_external_locations) | **GET** /apis/dbui/v1alpha1/workspaces/{workspace}/external-locations | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_list_users**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_list_users) | **GET** /apis/dbui/v1alpha1/workspaces/{workspace}/users | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_medallion_table_list**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_medallion_table_list) | **GET** /apis/dbui/v1alpha1/workspaces/{workspace}/medallion/{medallionLayer}/tables/list | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_promote_event_to_notable**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_promote_event_to_notable) | **POST** /apis/dbui/v1alpha1/workspaces/{workspace}/notables | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_table_preview**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_table_preview) | **GET** /apis/dbui/v1alpha1/workspaces/{workspace}/table-preview | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_token_exchange**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_token_exchange) | **GET** /apis/dbui/v1alpha1/token-exchange | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_transform**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_transform) | **POST** /apis/dbui/v1alpha1/workspaces/{workspace}/transform | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_update_notable**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_update_notable) | **POST** /apis/dbui/v1alpha1/workspaces/{workspace}/notables/update | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_update_observable_risk**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_update_observable_risk) | **POST** /apis/dbui/v1alpha1/workspaces/{workspace}/observables/kinds/{kind}/{value}/update | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_verify_auth**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_verify_auth) | **GET** /apis/dbui/v1alpha1/verify-auth | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_warehouse_get**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_warehouse_get) | **GET** /apis/dbui/v1alpha1/workspaces/{workspace}/warehouse/{id} | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_warehouse_list**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_warehouse_list) | **GET** /apis/dbui/v1alpha1/workspaces/{workspace}/warehouse | 
*DbuiV1alpha1Api* | [**dbui_v1_alpha1_warehouse_start**](docs/DbuiV1alpha1Api.md#dbui_v1_alpha1_warehouse_start) | **POST** /apis/dbui/v1alpha1/workspaces/{workspace}/warehouse/{id}/start | 
*WorkspaceV1alpha1Api* | [**workspace_v1_alpha1_authenticate**](docs/WorkspaceV1alpha1Api.md#workspace_v1_alpha1_authenticate) | **POST** /apis/workspace/v1alpha1/workspaces/{workspace}/authenticate | 
*WorkspaceV1alpha1Api* | [**workspace_v1_alpha1_create_service_account**](docs/WorkspaceV1alpha1Api.md#workspace_v1_alpha1_create_service_account) | **POST** /apis/workspace/v1alpha1/workspaces/{workspace}/serviceaccounts | 
*WorkspaceV1alpha1Api* | [**workspace_v1_alpha1_create_user**](docs/WorkspaceV1alpha1Api.md#workspace_v1_alpha1_create_user) | **POST** /apis/workspace/v1alpha1/workspaces/{workspace}/users | 
*WorkspaceV1alpha1Api* | [**workspace_v1_alpha1_create_workspace**](docs/WorkspaceV1alpha1Api.md#workspace_v1_alpha1_create_workspace) | **POST** /apis/workspace/v1alpha1/workspaces | 
*WorkspaceV1alpha1Api* | [**workspace_v1_alpha1_delete_admin_config**](docs/WorkspaceV1alpha1Api.md#workspace_v1_alpha1_delete_admin_config) | **DELETE** /apis/workspace/v1alpha1/workspaces/{workspace}/adminconfig | 
*WorkspaceV1alpha1Api* | [**workspace_v1_alpha1_delete_service_account**](docs/WorkspaceV1alpha1Api.md#workspace_v1_alpha1_delete_service_account) | **DELETE** /apis/workspace/v1alpha1/workspaces/{workspace}/serviceaccounts/{name} | 
*WorkspaceV1alpha1Api* | [**workspace_v1_alpha1_delete_user**](docs/WorkspaceV1alpha1Api.md#workspace_v1_alpha1_delete_user) | **DELETE** /apis/workspace/v1alpha1/workspaces/{workspace}/users/{email} | 
*WorkspaceV1alpha1Api* | [**workspace_v1_alpha1_get_admin_config**](docs/WorkspaceV1alpha1Api.md#workspace_v1_alpha1_get_admin_config) | **GET** /apis/workspace/v1alpha1/workspaces/{workspace}/adminconfig | 
*WorkspaceV1alpha1Api* | [**workspace_v1_alpha1_get_config**](docs/WorkspaceV1alpha1Api.md#workspace_v1_alpha1_get_config) | **GET** /apis/workspace/v1alpha1/workspaces/{workspace}/config | 
*WorkspaceV1alpha1Api* | [**workspace_v1_alpha1_get_rebalance**](docs/WorkspaceV1alpha1Api.md#workspace_v1_alpha1_get_rebalance) | **GET** /apis/workspace/v1alpha1/workspaces/{workspace}/rebalance | 
*WorkspaceV1alpha1Api* | [**workspace_v1_alpha1_get_service_account**](docs/WorkspaceV1alpha1Api.md#workspace_v1_alpha1_get_service_account) | **GET** /apis/workspace/v1alpha1/workspaces/{workspace}/serviceaccounts/{name} | 
*WorkspaceV1alpha1Api* | [**workspace_v1_alpha1_get_user**](docs/WorkspaceV1alpha1Api.md#workspace_v1_alpha1_get_user) | **GET** /apis/workspace/v1alpha1/workspaces/{workspace}/users/{email} | 
*WorkspaceV1alpha1Api* | [**workspace_v1_alpha1_list_service_accounts**](docs/WorkspaceV1alpha1Api.md#workspace_v1_alpha1_list_service_accounts) | **GET** /apis/workspace/v1alpha1/workspaces/{workspace}/serviceaccounts | 
*WorkspaceV1alpha1Api* | [**workspace_v1_alpha1_list_users**](docs/WorkspaceV1alpha1Api.md#workspace_v1_alpha1_list_users) | **GET** /apis/workspace/v1alpha1/workspaces/{workspace}/users | 
*WorkspaceV1alpha1Api* | [**workspace_v1_alpha1_post_rebalance**](docs/WorkspaceV1alpha1Api.md#workspace_v1_alpha1_post_rebalance) | **POST** /apis/workspace/v1alpha1/workspaces/{workspace}/rebalance | 
*WorkspaceV1alpha1Api* | [**workspace_v1_alpha1_put_admin_config**](docs/WorkspaceV1alpha1Api.md#workspace_v1_alpha1_put_admin_config) | **PUT** /apis/workspace/v1alpha1/workspaces/{workspace}/adminconfig | 
*WorkspaceV1alpha1Api* | [**workspace_v1_alpha1_put_config**](docs/WorkspaceV1alpha1Api.md#workspace_v1_alpha1_put_config) | **PUT** /apis/workspace/v1alpha1/workspaces/{workspace}/config | 
*WorkspaceV1alpha1Api* | [**workspace_v1_alpha1_replace_service_account**](docs/WorkspaceV1alpha1Api.md#workspace_v1_alpha1_replace_service_account) | **PUT** /apis/workspace/v1alpha1/workspaces/{workspace}/serviceaccounts/{name} | 
*WorkspaceV1alpha1Api* | [**workspace_v1_alpha1_replace_user**](docs/WorkspaceV1alpha1Api.md#workspace_v1_alpha1_replace_user) | **PUT** /apis/workspace/v1alpha1/workspaces/{workspace}/users/{email} | 


## Documentation For Models

 - [CommonV1alpha1JobMeta](docs/CommonV1alpha1JobMeta.md)
 - [CommonV1alpha1ListMeta](docs/CommonV1alpha1ListMeta.md)
 - [CommonV1alpha1ObjectMeta](docs/CommonV1alpha1ObjectMeta.md)
 - [ConflictError](docs/ConflictError.md)
 - [ContentV1alpha1DatasourcePreset](docs/ContentV1alpha1DatasourcePreset.md)
 - [ContentV1alpha1DatasourcePresetAutoloader](docs/ContentV1alpha1DatasourcePresetAutoloader.md)
 - [ContentV1alpha1DatasourcePresetGoldInner](docs/ContentV1alpha1DatasourcePresetGoldInner.md)
 - [ContentV1alpha1DatasourcePresetList](docs/ContentV1alpha1DatasourcePresetList.md)
 - [ContentV1alpha1DatasourcePresetListRecommendedPresetsInner](docs/ContentV1alpha1DatasourcePresetListRecommendedPresetsInner.md)
 - [ContentV1alpha1DatasourcePresetSilver](docs/ContentV1alpha1DatasourcePresetSilver.md)
 - [ContentV1alpha1DatasourcePresetSilverPreTransformInner](docs/ContentV1alpha1DatasourcePresetSilverPreTransformInner.md)
 - [ContentV1alpha1DatasourcePresetSilverTransformInner](docs/ContentV1alpha1DatasourcePresetSilverTransformInner.md)
 - [ContentV1alpha1MitreAttack](docs/ContentV1alpha1MitreAttack.md)
 - [ContentV1alpha1MitreSubTechnique](docs/ContentV1alpha1MitreSubTechnique.md)
 - [ContentV1alpha1MitreTactic](docs/ContentV1alpha1MitreTactic.md)
 - [ContentV1alpha1MitreTechnique](docs/ContentV1alpha1MitreTechnique.md)
 - [ContentV1alpha1MitreTechniqueDetail](docs/ContentV1alpha1MitreTechniqueDetail.md)
 - [ContentV1alpha1PresetDataSourceList](docs/ContentV1alpha1PresetDataSourceList.md)
 - [ContentV1alpha1PresetDataSourceListItemsInner](docs/ContentV1alpha1PresetDataSourceListItemsInner.md)
 - [CoreV1alpha1DataSource](docs/CoreV1alpha1DataSource.md)
 - [CoreV1alpha1DataSourceAutoloaderSpec](docs/CoreV1alpha1DataSourceAutoloaderSpec.md)
 - [CoreV1alpha1DataSourceAutoloaderSpecCloudFiles](docs/CoreV1alpha1DataSourceAutoloaderSpecCloudFiles.md)
 - [CoreV1alpha1DataSourceFieldSpec](docs/CoreV1alpha1DataSourceFieldSpec.md)
 - [CoreV1alpha1DataSourceFieldSpecAssertInner](docs/CoreV1alpha1DataSourceFieldSpecAssertInner.md)
 - [CoreV1alpha1DataSourceFieldSpecJoin](docs/CoreV1alpha1DataSourceFieldSpecJoin.md)
 - [CoreV1alpha1DataSourceFieldSpecJoinWithCSV](docs/CoreV1alpha1DataSourceFieldSpecJoinWithCSV.md)
 - [CoreV1alpha1DataSourceFieldUtils](docs/CoreV1alpha1DataSourceFieldUtils.md)
 - [CoreV1alpha1DataSourceFieldUtilsJsonExtractInner](docs/CoreV1alpha1DataSourceFieldUtilsJsonExtractInner.md)
 - [CoreV1alpha1DataSourceFieldUtilsUnreferencedColumns](docs/CoreV1alpha1DataSourceFieldUtilsUnreferencedColumns.md)
 - [CoreV1alpha1DataSourceList](docs/CoreV1alpha1DataSourceList.md)
 - [CoreV1alpha1DataSourceSpec](docs/CoreV1alpha1DataSourceSpec.md)
 - [CoreV1alpha1DataSourceSpecBronze](docs/CoreV1alpha1DataSourceSpecBronze.md)
 - [CoreV1alpha1DataSourceSpecBronzeClustering](docs/CoreV1alpha1DataSourceSpecBronzeClustering.md)
 - [CoreV1alpha1DataSourceSpecCustom](docs/CoreV1alpha1DataSourceSpecCustom.md)
 - [CoreV1alpha1DataSourceSpecGold](docs/CoreV1alpha1DataSourceSpecGold.md)
 - [CoreV1alpha1DataSourceSpecGoldPresetOverrides](docs/CoreV1alpha1DataSourceSpecGoldPresetOverrides.md)
 - [CoreV1alpha1DataSourceSpecGoldPresetOverridesAddTablesInner](docs/CoreV1alpha1DataSourceSpecGoldPresetOverridesAddTablesInner.md)
 - [CoreV1alpha1DataSourceSpecGoldPresetOverridesModifyTablesInner](docs/CoreV1alpha1DataSourceSpecGoldPresetOverridesModifyTablesInner.md)
 - [CoreV1alpha1DataSourceSpecSilver](docs/CoreV1alpha1DataSourceSpecSilver.md)
 - [CoreV1alpha1DataSourceSpecSilverBronzeTablesInner](docs/CoreV1alpha1DataSourceSpecSilverBronzeTablesInner.md)
 - [CoreV1alpha1DataSourceSpecSilverBronzeTablesInnerWatermark](docs/CoreV1alpha1DataSourceSpecSilverBronzeTablesInnerWatermark.md)
 - [CoreV1alpha1DataSourceSpecSilverPreTransform](docs/CoreV1alpha1DataSourceSpecSilverPreTransform.md)
 - [CoreV1alpha1DataSourceSpecSilverPreTransformCustom](docs/CoreV1alpha1DataSourceSpecSilverPreTransformCustom.md)
 - [CoreV1alpha1DataSourceSpecSilverPreTransformPresetOverrides](docs/CoreV1alpha1DataSourceSpecSilverPreTransformPresetOverrides.md)
 - [CoreV1alpha1DataSourceSpecSilverTransform](docs/CoreV1alpha1DataSourceSpecSilverTransform.md)
 - [CoreV1alpha1DataSourceSpecSilverTransformPresetOverrides](docs/CoreV1alpha1DataSourceSpecSilverTransformPresetOverrides.md)
 - [CoreV1alpha1DataSourceSpecSilverTransformPresetOverridesAddTablesInner](docs/CoreV1alpha1DataSourceSpecSilverTransformPresetOverridesAddTablesInner.md)
 - [CoreV1alpha1DataSourceSpecSilverTransformPresetOverridesModifyTablesInner](docs/CoreV1alpha1DataSourceSpecSilverTransformPresetOverridesModifyTablesInner.md)
 - [CoreV1alpha1DataSourceSpecSilverTransformPresetOverridesModifyTablesInnerCustom](docs/CoreV1alpha1DataSourceSpecSilverTransformPresetOverridesModifyTablesInnerCustom.md)
 - [CoreV1alpha1PostMetricsRequest](docs/CoreV1alpha1PostMetricsRequest.md)
 - [CoreV1alpha1PostMetricsRequestExecResultsInner](docs/CoreV1alpha1PostMetricsRequestExecResultsInner.md)
 - [CoreV1alpha1ResourceStatus](docs/CoreV1alpha1ResourceStatus.md)
 - [CoreV1alpha1Rule](docs/CoreV1alpha1Rule.md)
 - [CoreV1alpha1RuleList](docs/CoreV1alpha1RuleList.md)
 - [CoreV1alpha1RuleObservable](docs/CoreV1alpha1RuleObservable.md)
 - [CoreV1alpha1RuleObservableRisk](docs/CoreV1alpha1RuleObservableRisk.md)
 - [CoreV1alpha1RuleSpec](docs/CoreV1alpha1RuleSpec.md)
 - [CoreV1alpha1RuleSpecCollate](docs/CoreV1alpha1RuleSpecCollate.md)
 - [CoreV1alpha1RuleSpecInput](docs/CoreV1alpha1RuleSpecInput.md)
 - [CoreV1alpha1RuleSpecInputBatch](docs/CoreV1alpha1RuleSpecInputBatch.md)
 - [CoreV1alpha1RuleSpecInputStream](docs/CoreV1alpha1RuleSpecInputStream.md)
 - [CoreV1alpha1RuleSpecInputStreamCustom](docs/CoreV1alpha1RuleSpecInputStreamCustom.md)
 - [CoreV1alpha1RuleSpecInputStreamTablesInner](docs/CoreV1alpha1RuleSpecInputStreamTablesInner.md)
 - [CoreV1alpha1RuleSpecInputStreamTablesInnerWatermark](docs/CoreV1alpha1RuleSpecInputStreamTablesInnerWatermark.md)
 - [CoreV1alpha1RuleSpecMetadata](docs/CoreV1alpha1RuleSpecMetadata.md)
 - [CoreV1alpha1RuleSpecMetadataMitreInner](docs/CoreV1alpha1RuleSpecMetadataMitreInner.md)
 - [CoreV1alpha1RuleSpecMetadataResponse](docs/CoreV1alpha1RuleSpecMetadataResponse.md)
 - [CoreV1alpha1RuleSpecMetadataResponsePlaybooksInner](docs/CoreV1alpha1RuleSpecMetadataResponsePlaybooksInner.md)
 - [CoreV1alpha1RuleSpecOutput](docs/CoreV1alpha1RuleSpecOutput.md)
 - [CoreV1alpha1Schedule](docs/CoreV1alpha1Schedule.md)
 - [CoreV1alpha1StatusEvent](docs/CoreV1alpha1StatusEvent.md)
 - [CoreV1alpha1Transform](docs/CoreV1alpha1Transform.md)
 - [CoreV1alpha1TransformList](docs/CoreV1alpha1TransformList.md)
 - [CoreV1alpha1TransformSpec](docs/CoreV1alpha1TransformSpec.md)
 - [CoreV1alpha1TransformSpecStream](docs/CoreV1alpha1TransformSpecStream.md)
 - [CoreV1alpha1TransformSpecStreamTablesInner](docs/CoreV1alpha1TransformSpecStreamTablesInner.md)
 - [CoreV1alpha1TransformSpecStreamTablesInnerWatermark](docs/CoreV1alpha1TransformSpecStreamTablesInnerWatermark.md)
 - [DbuiV1alpha1AutoloaderPreviewRequest](docs/DbuiV1alpha1AutoloaderPreviewRequest.md)
 - [DbuiV1alpha1AutoloaderPreviewResponse](docs/DbuiV1alpha1AutoloaderPreviewResponse.md)
 - [DbuiV1alpha1CreateFunctionRequest](docs/DbuiV1alpha1CreateFunctionRequest.md)
 - [DbuiV1alpha1CreateFunctionResponse](docs/DbuiV1alpha1CreateFunctionResponse.md)
 - [DbuiV1alpha1CreateNotebookRequest](docs/DbuiV1alpha1CreateNotebookRequest.md)
 - [DbuiV1alpha1CreateNotebookResponse](docs/DbuiV1alpha1CreateNotebookResponse.md)
 - [DbuiV1alpha1DataSourceSummaryList](docs/DbuiV1alpha1DataSourceSummaryList.md)
 - [DbuiV1alpha1DataSourceSummaryListDataSourcesInner](docs/DbuiV1alpha1DataSourceSummaryListDataSourcesInner.md)
 - [DbuiV1alpha1DataSourceSummaryListDataSourcesInnerAlerts](docs/DbuiV1alpha1DataSourceSummaryListDataSourcesInnerAlerts.md)
 - [DbuiV1alpha1DataSourceSummaryListRollupMetrics](docs/DbuiV1alpha1DataSourceSummaryListRollupMetrics.md)
 - [DbuiV1alpha1DismissOperationalAlertsRequest](docs/DbuiV1alpha1DismissOperationalAlertsRequest.md)
 - [DbuiV1alpha1ExternalLocationList](docs/DbuiV1alpha1ExternalLocationList.md)
 - [DbuiV1alpha1ExternalLocationListLocationsInner](docs/DbuiV1alpha1ExternalLocationListLocationsInner.md)
 - [DbuiV1alpha1ListUsersResponse](docs/DbuiV1alpha1ListUsersResponse.md)
 - [DbuiV1alpha1ListUsersResponseUsersInner](docs/DbuiV1alpha1ListUsersResponseUsersInner.md)
 - [DbuiV1alpha1MedallionTableListResponse](docs/DbuiV1alpha1MedallionTableListResponse.md)
 - [DbuiV1alpha1Notable](docs/DbuiV1alpha1Notable.md)
 - [DbuiV1alpha1NotableCollate](docs/DbuiV1alpha1NotableCollate.md)
 - [DbuiV1alpha1NotableList](docs/DbuiV1alpha1NotableList.md)
 - [DbuiV1alpha1NotableSummary](docs/DbuiV1alpha1NotableSummary.md)
 - [DbuiV1alpha1ObservableEventsList](docs/DbuiV1alpha1ObservableEventsList.md)
 - [DbuiV1alpha1ObservableEventsListItemsInner](docs/DbuiV1alpha1ObservableEventsListItemsInner.md)
 - [DbuiV1alpha1ObservableEventsListItemsInnerNotable](docs/DbuiV1alpha1ObservableEventsListItemsInnerNotable.md)
 - [DbuiV1alpha1ObservableInstance](docs/DbuiV1alpha1ObservableInstance.md)
 - [DbuiV1alpha1ObservableInstanceRisk](docs/DbuiV1alpha1ObservableInstanceRisk.md)
 - [DbuiV1alpha1ObservableList](docs/DbuiV1alpha1ObservableList.md)
 - [DbuiV1alpha1ObservableTop10List](docs/DbuiV1alpha1ObservableTop10List.md)
 - [DbuiV1alpha1ObservableTop10ListItemsInner](docs/DbuiV1alpha1ObservableTop10ListItemsInner.md)
 - [DbuiV1alpha1ObservableTop10ListItemsInnerTop10Inner](docs/DbuiV1alpha1ObservableTop10ListItemsInnerTop10Inner.md)
 - [DbuiV1alpha1ObservableTop10Reply](docs/DbuiV1alpha1ObservableTop10Reply.md)
 - [DbuiV1alpha1ObservableTop10ReplyItemsInner](docs/DbuiV1alpha1ObservableTop10ReplyItemsInner.md)
 - [DbuiV1alpha1ObservableTop10ReplyItemsInnerTop10Inner](docs/DbuiV1alpha1ObservableTop10ReplyItemsInnerTop10Inner.md)
 - [DbuiV1alpha1OperationalAlert](docs/DbuiV1alpha1OperationalAlert.md)
 - [DbuiV1alpha1OperationalAlertList](docs/DbuiV1alpha1OperationalAlertList.md)
 - [DbuiV1alpha1OperationalAlertSummary](docs/DbuiV1alpha1OperationalAlertSummary.md)
 - [DbuiV1alpha1PromoteEventRequest](docs/DbuiV1alpha1PromoteEventRequest.md)
 - [DbuiV1alpha1SchemaCheckResponse](docs/DbuiV1alpha1SchemaCheckResponse.md)
 - [DbuiV1alpha1TableColumnDetails](docs/DbuiV1alpha1TableColumnDetails.md)
 - [DbuiV1alpha1TableColumnList](docs/DbuiV1alpha1TableColumnList.md)
 - [DbuiV1alpha1TablePreview](docs/DbuiV1alpha1TablePreview.md)
 - [DbuiV1alpha1TransformRequest](docs/DbuiV1alpha1TransformRequest.md)
 - [DbuiV1alpha1TransformRequestInput](docs/DbuiV1alpha1TransformRequestInput.md)
 - [DbuiV1alpha1TransformRequestPresetOverrides](docs/DbuiV1alpha1TransformRequestPresetOverrides.md)
 - [DbuiV1alpha1TransformResponse](docs/DbuiV1alpha1TransformResponse.md)
 - [DbuiV1alpha1UpdateNotablesRequest](docs/DbuiV1alpha1UpdateNotablesRequest.md)
 - [DbuiV1alpha1UpdateObservableRequest](docs/DbuiV1alpha1UpdateObservableRequest.md)
 - [DbuiV1alpha1UpdateObservableRiskRequest](docs/DbuiV1alpha1UpdateObservableRiskRequest.md)
 - [DbuiV1alpha1VerifyAuthResponse](docs/DbuiV1alpha1VerifyAuthResponse.md)
 - [DbuiV1alpha1WarehouseItem](docs/DbuiV1alpha1WarehouseItem.md)
 - [DbuiV1alpha1WarehouseListResponse](docs/DbuiV1alpha1WarehouseListResponse.md)
 - [Error](docs/Error.md)
 - [ForbiddenError](docs/ForbiddenError.md)
 - [InvalidRequestError](docs/InvalidRequestError.md)
 - [PreconditionFailedError](docs/PreconditionFailedError.md)
 - [ResourceExhaustedError](docs/ResourceExhaustedError.md)
 - [ResourceNotFoundError](docs/ResourceNotFoundError.md)
 - [UnauthorizedError](docs/UnauthorizedError.md)
 - [WorkspaceV1alpha1AdminConfig](docs/WorkspaceV1alpha1AdminConfig.md)
 - [WorkspaceV1alpha1AdminConfigSpec](docs/WorkspaceV1alpha1AdminConfigSpec.md)
 - [WorkspaceV1alpha1AdminConfigSpecAuth](docs/WorkspaceV1alpha1AdminConfigSpecAuth.md)
 - [WorkspaceV1alpha1AdminConfigSpecAuthAppClientId](docs/WorkspaceV1alpha1AdminConfigSpecAuthAppClientId.md)
 - [WorkspaceV1alpha1AdminConfigSpecAuthServicePrincipal](docs/WorkspaceV1alpha1AdminConfigSpecAuthServicePrincipal.md)
 - [WorkspaceV1alpha1AdminConfigStatus](docs/WorkspaceV1alpha1AdminConfigStatus.md)
 - [WorkspaceV1alpha1AuthenticateRequest](docs/WorkspaceV1alpha1AuthenticateRequest.md)
 - [WorkspaceV1alpha1AuthenticateResponse](docs/WorkspaceV1alpha1AuthenticateResponse.md)
 - [WorkspaceV1alpha1CreateServiceAccountRequest](docs/WorkspaceV1alpha1CreateServiceAccountRequest.md)
 - [WorkspaceV1alpha1CreateServiceAccountResponse](docs/WorkspaceV1alpha1CreateServiceAccountResponse.md)
 - [WorkspaceV1alpha1CreateWorkspaceRequest](docs/WorkspaceV1alpha1CreateWorkspaceRequest.md)
 - [WorkspaceV1alpha1CreateWorkspaceResponse](docs/WorkspaceV1alpha1CreateWorkspaceResponse.md)
 - [WorkspaceV1alpha1DefaultConfig](docs/WorkspaceV1alpha1DefaultConfig.md)
 - [WorkspaceV1alpha1DefaultConfigComputeGroupOverridesValue](docs/WorkspaceV1alpha1DefaultConfigComputeGroupOverridesValue.md)
 - [WorkspaceV1alpha1ExportConfig](docs/WorkspaceV1alpha1ExportConfig.md)
 - [WorkspaceV1alpha1ExportConfigSlackConfig](docs/WorkspaceV1alpha1ExportConfigSlackConfig.md)
 - [WorkspaceV1alpha1ExportConfigWebhookConfig](docs/WorkspaceV1alpha1ExportConfigWebhookConfig.md)
 - [WorkspaceV1alpha1ExportConfigWebhookConfigDestination](docs/WorkspaceV1alpha1ExportConfigWebhookConfigDestination.md)
 - [WorkspaceV1alpha1RebalanceInfo](docs/WorkspaceV1alpha1RebalanceInfo.md)
 - [WorkspaceV1alpha1RebalanceInfoStatus](docs/WorkspaceV1alpha1RebalanceInfoStatus.md)
 - [WorkspaceV1alpha1RebalanceInfoStatusResourcesInner](docs/WorkspaceV1alpha1RebalanceInfoStatusResourcesInner.md)
 - [WorkspaceV1alpha1ServiceAccount](docs/WorkspaceV1alpha1ServiceAccount.md)
 - [WorkspaceV1alpha1ServiceAccountCredentials](docs/WorkspaceV1alpha1ServiceAccountCredentials.md)
 - [WorkspaceV1alpha1ServiceAccountList](docs/WorkspaceV1alpha1ServiceAccountList.md)
 - [WorkspaceV1alpha1ServiceAccountSpec](docs/WorkspaceV1alpha1ServiceAccountSpec.md)
 - [WorkspaceV1alpha1ServiceAccountStatus](docs/WorkspaceV1alpha1ServiceAccountStatus.md)
 - [WorkspaceV1alpha1User](docs/WorkspaceV1alpha1User.md)
 - [WorkspaceV1alpha1UserList](docs/WorkspaceV1alpha1UserList.md)
 - [WorkspaceV1alpha1UserSpec](docs/WorkspaceV1alpha1UserSpec.md)
 - [WorkspaceV1alpha1UserStatus](docs/WorkspaceV1alpha1UserStatus.md)
 - [WorkspaceV1alpha1WorkspaceConfig](docs/WorkspaceV1alpha1WorkspaceConfig.md)
 - [WorkspaceV1alpha1WorkspaceConfigSpec](docs/WorkspaceV1alpha1WorkspaceConfigSpec.md)
 - [WorkspaceV1alpha1WorkspaceConfigSpecComputeGroupLimitsInner](docs/WorkspaceV1alpha1WorkspaceConfigSpecComputeGroupLimitsInner.md)
 - [WorkspaceV1alpha1WorkspaceConfigSpecDefaultConfig](docs/WorkspaceV1alpha1WorkspaceConfigSpecDefaultConfig.md)
 - [WorkspaceV1alpha1WorkspaceConfigSpecDetectionRuleMetadata](docs/WorkspaceV1alpha1WorkspaceConfigSpecDetectionRuleMetadata.md)
 - [WorkspaceV1alpha1WorkspaceConfigSpecManagedRetentionInner](docs/WorkspaceV1alpha1WorkspaceConfigSpecManagedRetentionInner.md)
 - [WorkspaceV1alpha1WorkspaceConfigSpecManagedRetentionInnerOverridesInner](docs/WorkspaceV1alpha1WorkspaceConfigSpecManagedRetentionInnerOverridesInner.md)
 - [WorkspaceV1alpha1WorkspaceConfigSpecObservables](docs/WorkspaceV1alpha1WorkspaceConfigSpecObservables.md)
 - [WorkspaceV1alpha1WorkspaceConfigSpecObservablesKindsInner](docs/WorkspaceV1alpha1WorkspaceConfigSpecObservablesKindsInner.md)
 - [WorkspaceV1alpha1WorkspaceConfigSpecSystemTablesConfig](docs/WorkspaceV1alpha1WorkspaceConfigSpecSystemTablesConfig.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="account_identity"></a>
### account_identity

- **Type**: Bearer authentication (JWT)

<a id="databricks_oauth_token"></a>
### databricks_oauth_token

- **Type**: Bearer authentication (JWT)


## Author

support@antimatter.io


