# coding: utf-8

"""
    Antimatter Security Lakehouse Public API

    Interact with the Antimatter ASL API

    The version of the OpenAPI document: 0.0.4
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class CommonV1alpha1ObjectMeta(BaseModel):
    """
    CommonV1alpha1ObjectMeta
    """ # noqa: E501
    name: Optional[StrictStr] = None
    workspace: Optional[StrictStr] = None
    comment: Optional[StrictStr] = None
    annotations: Optional[Dict[str, StrictStr]] = Field(default=None, description="Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects.")
    created_timestamp: Optional[datetime] = Field(default=None, alias="createdTimestamp")
    created_by: Optional[StrictStr] = Field(default=None, description="the account that created this resource", alias="createdBy")
    modified_timestamp: Optional[datetime] = Field(default=None, alias="modifiedTimestamp")
    modified_by: Optional[StrictStr] = Field(default=None, description="the account that modified this resource", alias="modifiedBy")
    uid: Optional[StrictStr] = Field(default=None, description="A unique identifier for this resource, allocated by the server")
    version: Optional[StrictInt] = Field(default=None, description="The resource's version.")
    deleted: Optional[StrictBool] = Field(default=None, description="Indicates whether the resource has been deleted.")
    resource_status: Optional[StrictStr] = Field(default='none', alias="resourceStatus")
    __properties: ClassVar[List[str]] = ["name", "workspace", "comment", "annotations", "createdTimestamp", "createdBy", "modifiedTimestamp", "modifiedBy", "uid", "version", "deleted", "resourceStatus"]

    @field_validator('resource_status')
    def resource_status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['none', 'deletionPending', 'reparentPending', 'reparentForRebalance', 'rebalancePending']):
            raise ValueError("must be one of enum values ('none', 'deletionPending', 'reparentPending', 'reparentForRebalance', 'rebalancePending')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CommonV1alpha1ObjectMeta from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CommonV1alpha1ObjectMeta from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "workspace": obj.get("workspace"),
            "comment": obj.get("comment"),
            "annotations": obj.get("annotations"),
            "createdTimestamp": obj.get("createdTimestamp"),
            "createdBy": obj.get("createdBy"),
            "modifiedTimestamp": obj.get("modifiedTimestamp"),
            "modifiedBy": obj.get("modifiedBy"),
            "uid": obj.get("uid"),
            "version": obj.get("version"),
            "deleted": obj.get("deleted"),
            "resourceStatus": obj.get("resourceStatus") if obj.get("resourceStatus") is not None else 'none'
        })
        return _obj


