# coding: utf-8

"""
    Antimatter Security Lakehouse Public API

    Interact with the Antimatter ASL API

    The version of the OpenAPI document: 0.0.4
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from dasl_api.models.core_v1alpha1_rule_spec_input_stream_custom import CoreV1alpha1RuleSpecInputStreamCustom
from dasl_api.models.core_v1alpha1_rule_spec_input_stream_tables_inner import CoreV1alpha1RuleSpecInputStreamTablesInner
from typing import Optional, Set
from typing_extensions import Self

class CoreV1alpha1RuleSpecInputStream(BaseModel):
    """
    CoreV1alpha1RuleSpecInputStream
    """ # noqa: E501
    tables: Optional[List[CoreV1alpha1RuleSpecInputStreamTablesInner]] = None
    filter: Optional[StrictStr] = None
    sql: Optional[StrictStr] = None
    custom: Optional[CoreV1alpha1RuleSpecInputStreamCustom] = None
    __properties: ClassVar[List[str]] = ["tables", "filter", "sql", "custom"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CoreV1alpha1RuleSpecInputStream from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in tables (list)
        _items = []
        if self.tables:
            for _item_tables in self.tables:
                if _item_tables:
                    _items.append(_item_tables.to_dict())
            _dict['tables'] = _items
        # override the default output from pydantic by calling `to_dict()` of custom
        if self.custom:
            _dict['custom'] = self.custom.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CoreV1alpha1RuleSpecInputStream from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "tables": [CoreV1alpha1RuleSpecInputStreamTablesInner.from_dict(_item) for _item in obj["tables"]] if obj.get("tables") is not None else None,
            "filter": obj.get("filter"),
            "sql": obj.get("sql"),
            "custom": CoreV1alpha1RuleSpecInputStreamCustom.from_dict(obj["custom"]) if obj.get("custom") is not None else None
        })
        return _obj


