# coding: utf-8

"""
    Antimatter Security Lakehouse Public API

    Interact with the Antimatter ASL API

    The version of the OpenAPI document: 0.0.4
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from dasl_api.models.core_v1alpha1_rule_spec_input_stream_tables_inner_watermark import CoreV1alpha1RuleSpecInputStreamTablesInnerWatermark
from typing import Optional, Set
from typing_extensions import Self

class CoreV1alpha1RuleSpecInputStreamTablesInner(BaseModel):
    """
    CoreV1alpha1RuleSpecInputStreamTablesInner
    """ # noqa: E501
    name: Optional[StrictStr] = None
    watermark: Optional[CoreV1alpha1RuleSpecInputStreamTablesInnerWatermark] = None
    alias: Optional[StrictStr] = Field(default=None, description="alias name for the table")
    join_type: Optional[StrictStr] = Field(default=None, description="for tables other than the first, how to join to the preceding table", alias="joinType")
    join_expr: Optional[StrictStr] = Field(default=None, description="for tables other than the first, the join condition expression to join with the preceding table", alias="joinExpr")
    __properties: ClassVar[List[str]] = ["name", "watermark", "alias", "joinType", "joinExpr"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CoreV1alpha1RuleSpecInputStreamTablesInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of watermark
        if self.watermark:
            _dict['watermark'] = self.watermark.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CoreV1alpha1RuleSpecInputStreamTablesInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "watermark": CoreV1alpha1RuleSpecInputStreamTablesInnerWatermark.from_dict(obj["watermark"]) if obj.get("watermark") is not None else None,
            "alias": obj.get("alias"),
            "joinType": obj.get("joinType"),
            "joinExpr": obj.get("joinExpr")
        })
        return _obj


