# coding: utf-8

"""
    Antimatter Security Lakehouse Public API

    Interact with the Antimatter ASL API

    The version of the OpenAPI document: 0.0.4
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from dasl_api.models.core_v1alpha1_data_source_field_spec import CoreV1alpha1DataSourceFieldSpec
from dasl_api.models.dbui_v1alpha1_transform_request_input import DbuiV1alpha1TransformRequestInput
from dasl_api.models.dbui_v1alpha1_transform_request_preset_overrides import DbuiV1alpha1TransformRequestPresetOverrides
from typing import Optional, Set
from typing_extensions import Self

class DbuiV1alpha1TransformRequest(BaseModel):
    """
    DbuiV1alpha1TransformRequest
    """ # noqa: E501
    transform_type: StrictStr = Field(alias="transformType")
    use_preset: Optional[StrictStr] = Field(default=None, alias="usePreset")
    use_preset_table: Optional[StrictStr] = Field(default=None, description="Used with Gold/Silver transformType preset to determine which table preset to use.", alias="usePresetTable")
    filter: Optional[StrictStr] = None
    post_filter: Optional[StrictStr] = Field(default=None, alias="postFilter")
    preset_overrides: Optional[DbuiV1alpha1TransformRequestPresetOverrides] = Field(default=None, alias="presetOverrides")
    add_fields: Optional[List[CoreV1alpha1DataSourceFieldSpec]] = Field(default=None, alias="addFields")
    input: DbuiV1alpha1TransformRequestInput
    __properties: ClassVar[List[str]] = ["transformType", "usePreset", "usePresetTable", "filter", "postFilter", "presetOverrides", "addFields", "input"]

    @field_validator('transform_type')
    def transform_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['Pre', 'Silver', 'Gold']):
            raise ValueError("must be one of enum values ('Pre', 'Silver', 'Gold')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DbuiV1alpha1TransformRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of preset_overrides
        if self.preset_overrides:
            _dict['presetOverrides'] = self.preset_overrides.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in add_fields (list)
        _items = []
        if self.add_fields:
            for _item_add_fields in self.add_fields:
                if _item_add_fields:
                    _items.append(_item_add_fields.to_dict())
            _dict['addFields'] = _items
        # override the default output from pydantic by calling `to_dict()` of input
        if self.input:
            _dict['input'] = self.input.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DbuiV1alpha1TransformRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "transformType": obj.get("transformType"),
            "usePreset": obj.get("usePreset"),
            "usePresetTable": obj.get("usePresetTable"),
            "filter": obj.get("filter"),
            "postFilter": obj.get("postFilter"),
            "presetOverrides": DbuiV1alpha1TransformRequestPresetOverrides.from_dict(obj["presetOverrides"]) if obj.get("presetOverrides") is not None else None,
            "addFields": [CoreV1alpha1DataSourceFieldSpec.from_dict(_item) for _item in obj["addFields"]] if obj.get("addFields") is not None else None,
            "input": DbuiV1alpha1TransformRequestInput.from_dict(obj["input"]) if obj.get("input") is not None else None
        })
        return _obj


