# coding: utf-8

"""
    Antimatter Security Lakehouse Public API

    Interact with the Antimatter ASL API

    The version of the OpenAPI document: 0.0.4
    Contact: support@antimatter.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from dasl_api.models.workspace_v1alpha1_default_config_compute_group_overrides_value import WorkspaceV1alpha1DefaultConfigComputeGroupOverridesValue
from typing import Optional, Set
from typing_extensions import Self

class WorkspaceV1alpha1DefaultConfig(BaseModel):
    """
    Default configuration for a specific type 
    """ # noqa: E501
    notebook_location: Optional[StrictStr] = Field(default=None, description="A location for user provided/edited notebook", alias="notebookLocation")
    bronze_schema: Optional[StrictStr] = Field(default=None, alias="bronzeSchema")
    silver_schema: Optional[StrictStr] = Field(default=None, alias="silverSchema")
    gold_schema: Optional[StrictStr] = Field(default=None, alias="goldSchema")
    catalog_name: Optional[StrictStr] = Field(default=None, alias="catalogName")
    default_max_resources_per_job: Optional[StrictInt] = Field(default=None, alias="defaultMaxResourcesPerJob")
    checkpoint_location: Optional[StrictStr] = Field(default=None, alias="checkpointLocation")
    compute_group_overrides: Optional[Dict[str, WorkspaceV1alpha1DefaultConfigComputeGroupOverridesValue]] = Field(default=None, alias="computeGroupOverrides")
    __properties: ClassVar[List[str]] = ["notebookLocation", "bronzeSchema", "silverSchema", "goldSchema", "catalogName", "defaultMaxResourcesPerJob", "checkpointLocation", "computeGroupOverrides"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of WorkspaceV1alpha1DefaultConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each value in compute_group_overrides (dict)
        _field_dict = {}
        if self.compute_group_overrides:
            for _key_compute_group_overrides in self.compute_group_overrides:
                if self.compute_group_overrides[_key_compute_group_overrides]:
                    _field_dict[_key_compute_group_overrides] = self.compute_group_overrides[_key_compute_group_overrides].to_dict()
            _dict['computeGroupOverrides'] = _field_dict
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of WorkspaceV1alpha1DefaultConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "notebookLocation": obj.get("notebookLocation"),
            "bronzeSchema": obj.get("bronzeSchema"),
            "silverSchema": obj.get("silverSchema"),
            "goldSchema": obj.get("goldSchema"),
            "catalogName": obj.get("catalogName"),
            "defaultMaxResourcesPerJob": obj.get("defaultMaxResourcesPerJob"),
            "checkpointLocation": obj.get("checkpointLocation"),
            "computeGroupOverrides": dict(
                (_k, WorkspaceV1alpha1DefaultConfigComputeGroupOverridesValue.from_dict(_v))
                for _k, _v in obj["computeGroupOverrides"].items()
            )
            if obj.get("computeGroupOverrides") is not None
            else None
        })
        return _obj


